Class CheckerEvent : StaticEventHandler
{
  Class <Actor> CheckModActor;
  Class <Actor> CheckWadActor;
  bool isRavage;

  // current values for whichMod CVar are: CF(0), RO(1), EoA(2), GC(3), TB(4), PB(5), MoPiX(6)
  // current values for whichWad CVar are: non-special Wad(0), Mapwich2(1), Eviternity(2), RR(3)

  Array<string> ModActorCheck;
  Array<string> WadActorCheck;
  Array<string> ModReplacer;

  Override void OnRegister()
  {
	SetOrder(1);
	int x=0; int y=0; 
  
	CVar CCardsLoaded = CVar.GetCVar("ccards_mintier");
	if (CCardsLoaded) { CVar.GetCVar("cf_isCCards").SetInt(1); }
	else { CVar.GetCVar("cf_isCCards").SetInt(0); }

	PreCheck(); CVar whichModpointer = CVar.GetCVar("whichMod"); CVar whichWadPointer = CVar.GetCVar("whichWad");
	if(whichModPointer) 
	{
      while( x < ModActorCheck.size() )
      {
		CheckModActor = (Class<Actor>) (ModActorCheck[x]);
        if(CheckModActor) 
		{
		  whichModPointer.SetInt(x+1); Console.Printf("\cdYou are playing \cg"..Stringtable.Localize("$ModName"..(x+1))..".\cd If not, contact the technical support"); break;
		}
		x++;
	  }
      PostCheck(whichModPointer.GetInt());
	}
	if (whichWadPointer) 
	{
		while ( y < WadActorCheck.size() )
      {
		CheckWadActor = (Class<Actor>) (WadActorCheck[y]);
		if (CheckWadActor) { whichWadPointer.SetInt(y+1); Console.Printf("\cdYou are playing \cg"..Stringtable.Localize("$WadName"..y).."\cd. If not, contact the technical support"); break; }
		y++;
      }
	}

  } //On Register

  void PreCheck()
  {
	int t = 0;
	while (Stringtable.Localize("$WadActorCheck"..t) != "Stop") { WadActorCheck.Push(Stringtable.Localize("$WadActorCheck"..t)); t++; } 
	t = 0;
	while (Stringtable.Localize("$ModActorCheck"..t) != "Stop") { ModActorCheck.Push(Stringtable.Localize("$ModActorCheck"..t)); t++; } 
  }

  void PostCheck(int A)
  {
	if (A == 0) { return; }
	int t = 0;
	while (t < 21) { ModReplacer.Push(Stringtable.Localize("$Mod"..A.."Replacer"..t)); t++; } 
  }
  //CFCards stuff
  Override void NewGame() { CVar.GetCVar("cfcards_killscore").SetInt(0); }
}

Class SpawnCheck : StaticEventHandler
{
  Override void WorldThingSpawned (WorldEvent e)
  {
	if (e.thing && e.thing.bMISSILE)
	{
	  if (e.thing.target && e.thing.target.bFRIENDLY && !e.thing.target.player)
	  { e.thing.bFRIENDLY = True; e.thing.A_SetSpecies('Player'); e.thing.GiveInventory("ProjectileFlags",1); }
	}
	if (e.thing && e.thing.bISMONSTER)
	{
	  if (e.thing.bFRIENDLY)
	  {
	    e.thing.ACS_NamedExecuteAlways("Set Species",0); e.thing.GiveInventory("LegDoomguyDoubleDamagePowerUp",1); e.thing.GiveInventory("RingOfRegenerationQuiet",1);
		e.thing.GiveInventory("FriendlyMonsterDF",1); e.thing.GiveInventory("FriendlyFlags",1); e.thing.GiveInventory("FriendlyProtection",1);
	  }
	}
	if (e.thing && e.thing.bMISSILE && e.thing.target)
	{
	  if (e.thing.target.target && e.thing.target.target.bFRIENDLY && e.thing.target.target.FindInventory("FriendlyMonsterSignCheck")) { e.thing.A_SetDamageType('Monster'); }
	  if (e.thing.target.bFRIENDLY && e.thing.target.bISMONSTER) { e.thing.A_SetSpecies('Player'); e.thing.A_SetDamageType('Player'); }
	}
  }
}
Class RR_TinyFix : StaticEventHandler
{
  bool isRavage;
  Override void NewGame()
  {
	if (level.LevelName ~== "TitleMap") { return; }
	if (whichWad != 3) { Destroy(); }
  }
  Override void WorldLoaded (WorldEvent e) { if (level.LevelName ~== "Ravage") { isRavage=true; }
  }
 
  Override void WorldThingSpawned (WorldEvent e)
  {
	if (!isRavage) { return; }
	if (e.thing && e.thing.bISMONSTER && e.thing.TID == 62 && e.thing.GetClassName() != 'CFMancubusSpawner') { e.thing.ChangeTID(666666); }
  }
  Override void WorldThingDied (WorldEvent e)
  {
	if (!isRavage) {return;}
	if (!e.thing || !e.thing.bISMONSTER || e.thing is "CFMonsterSpawnerBase") { return; }
	if (e.thing.TID == 62 && e.thing.GetSpecies() == 'Fatsos') { CallACS("RRTinyFix"); }
  }
}
