///// <== this separates each card

Class CCard_CursedMoloch : Card
{
  mixin TonynMixin;
  CCards_Actor_SafeSpawner spawner;
  bool isSpawning,finished;
  string BossItem;
  int spawnchance;

  override void Init()
	{
	effectplayers = true;
	tier = 3;
	description = "A VERY cursed Moloch will spawn.";
	alwaysoffer = true;
	image = "CCMOLO";
	background = "CARD81";
	canStack = false;
	}

   override bool Condition()
   {
	Setting(0);

	if(handler && global)
	 {
	   //check "extra.zscript" to see what these functions do
	   if(MaxOffer()) {return false;}

	   if(WildCondition()==1) {return false;}
	   else if(WildCondition()==2) {return true;}

	   if(MapCondition()) {return true;}
	 }

	return false;
   }

  override void OnGameStart(Actor a)
	{
	 WildChosen();
	 SetEventTotals();
	 let gp = CCards_Functions.GetGame();
	 if(!gp.permanentChoice) {spawnchance = 3;}
	 else {spawnchance = random(1,2);}
	 BossItem = "IsBoss";

	 if(global.Offers[cardnum] != 0) {OfferAndWildReset();}

	 isSpawning = false;
	 finished = false;
	}

 override void OnTick(actor a)
  {
	 if(finished || spawnchance == 2) {return;}

		
	 if(isSpawning)
	 {
	  ThinkerIterator ti = ThinkerIterator.Create("CursedMoloch");
			
	  Actor t;
			
	  while (t = Actor(ti.Next()))
	  {
		if(t)
		{
		 t.target = a;
		 t.lastheard = a;
		 t.bNOBLOCKMONST = true;
		 t.bNOTARGETSWITCH = true;
		 t.GiveInventory(BossItem,1);
		 finished = true;
		 break;
		}
	  }

	  return;
	 }
		
	 if(EventTrigger())
	 {
	  spawner = CCards_Safespawner.Create("CursedMoloch", 1, "CCards_Actor_BigSpawnFire", 40, 110, 250, 5);
	  if(a && spawner) {spawner.SetSpawnLocation(a); isSpawning = true;}
	 }
  }
}

///// Card LSDCurse

Class CCard_LSDCurse: CCard_CursedMoloch
{

  override void Init()
	{
	effectPlayers = true;
	tier = 4;
	description = "A VERY cursed Abyssal Satyr will spawn.";
	alwaysoffer = true;
	image = "LSDCUR";
	background = "";
	canStack = false;
	}

   override bool Condition()
   {
	Setting(1);

	if(handler && global)
	 {
	   //check "extra.zscript" to see what these functions do
	   if(MaxOffer()) {return false;}

	   if(WildCondition()==1) {return false;}
	   else if(WildCondition()==2) {return true;}

	   if(MapCondition()) {return true;}
	 }

	return false;
   }

 override void OnTick(actor a)
  {
	 if(finished || spawnchance == 2) {return;}

		
	 if(isSpawning)
	 {
	  ThinkerIterator ti = ThinkerIterator.Create("CursedSatyr");
			
	  Actor t;
			
	  while (t = Actor(ti.Next()))
	  {
		if(t)
		{
		 t.target = a;
		 t.lastheard = a;
		 t.bNOBLOCKMONST = true;
		 t.bNOTARGETSWITCH = true;
		 if(spawnchance == 3) {t.GiveInventory("SatyrCurse",1);}
		 t.GiveInventory("SatyrCurse",1);
 		 t.GiveInventory(BossItem,1);
		 finished = true;
		 break;
		}
	  }

	  return;
	 }
		
	 if(EventTrigger())
	 {
	  spawner = CCards_Safespawner.Create("CursedSatyr", 1, "CCards_Actor_BigSpawnFire", 40, 110, 250, 5);
	  if(a && spawner) {spawner.SetSpawnLocation(a); isSpawning = true;}
	 }
  }
}


///// Enhanced Card Chicken Curse
// CCards_Actor_SafeSpawner New(String a, int amount, String fx, int radius, int height, int minspawnradius, int flags)

Class CCard_OmegaChickenHazard : CCard_ChickenHazard
{
 override void Init()
 {
 effectWorld = true;
 tier = 5; //should be Tier 666
 description = "Chickens will appear. Avoid killing them \cgfor the love of Jesus Christ!";
 background = "CARD40";
 image = "CFCHICK";
 canStack = false;
 customFrame = "graphics/selector/cbordp.png";
 cardtag = TAG_TRAP;
// wildcard = true;
 alwaysoffer = true;
 }

 mixin TonynMixin;
 bool finished; int x,y, spawncount2;
 Class<Actor> gameover;

 static const string Monster_Names[] = {"CFLegendaryDoomguy","CFHeresiarch","Mainyu","HellfireCyberdemon"};
 static const int Monster_Amounts[] = {12,7,10,9};

   override bool Condition()
   {
	Setting(2);

	if(handler && global)
	 {
	   //check "extra.zscript" to see what these functions do
	   if(MaxOffer()) {return false;}

	   if(WildCondition()==1) {return false;}
	   else if(WildCondition()==2) {return true;}

	   if(MapCondition()) {return true;}
	 }

	return false;
   }


 override void OnGameStart(Actor a)
 {
	WildChosen();
	if(global.Offers[cardnum] != 0) {OfferAndWildReset();}

	killedchickens = 0;
	armageddontimer = 0;
	y = random(0,3); 
	finished=false;
	spawncount = random(45,60); //Min(spawncount2, 120);
 }
	
 override void OnTick(Actor a)
 {
	 if(finished) {return;}

	 if(spawncount > 0 && (Level.Time % 2) == 0)
	 {
	  CCards_Safespawner.Create("CCards_Actor_Chicken", spawncount, "CCards_Actor_ItemFog", 28, 16, 0, 2);
	  spawncount = 0;
	 }

	 if(armageddontimer > 0)
	 {
	  finished=true;
	  gameover = (Class<Actor>)(Monster_Names[y]);

	  if(!gameover) { Console.Printf("\cgGAMEOVER ERROR"); return; } 

	  players[0].mo.ACS_NamedExecuteAlways("OmegaChicken",0,y);

	  x=Monster_Amounts[y];
	  while(x > 0)
 	   {
	    CCards_Safespawner.Create(Monster_Names[y], 1, "CCards_Actor_BigSpawnFire", GetDefaultByType(gameover).radius, GetDefaultByType(gameover).height, 400, 5);
	    x--;
	   }
	 }
 }
}



///// Enhanced Card BarrelsOfFun

Class CCard_BarrelsOfClusterfun : CCard_BarrelsOfFun
{
	override void Init()
	{
	effectWorld = true;
	tier = 2;
	description = "Add lots of explosive bullshit to the level.";
	image = "CFBARL";
	background = "CARB08";
	canStack = true;
	cardtag = TAG_TRAP;
	}


	override void OnTick(Actor a)
	{
		if(spawncount > 0 && (Level.Time % 2) == 0)
		{
			CCards_Safespawner.Create("CCards_Actor_CardExplosiveBarrel2", spawncount, "CCards_Actor_ItemFog", 10, 42, 0, 1);
			spawncount = 0;
		}
	}

}


///// Card Zkurveny barrels

Class CCard_BarrelsHaveEyes : CCard_BarrelsOfFun
{
	override void Init()
	{
	effectPlayers = true;
	tier = 2;
	description = "Add some weird and \cvvery innocent\cf explosive barrels to the level.";
	image = "CFEYES";
	background = "";
	canStack = true;
	cardtag = TAG_TRAP;
	//alwaysoffer = true;
	}


	override void OnGameStart(Actor a)
	{
		spawncount = Random(15, 25);
	}


	override void OnTick(Actor a)
	{
		if(spawncount > 0 && (Level.Time % 2) == 0)
		{
			CCards_Safespawner.Create("CCards_Actor_CardEyedBarrel", spawncount, "CCards_Actor_ItemFog", 10, 42, 0, 1);
			spawncount = 0;
		}
	}
}


///// Card TruePhase

Class CCard_TruePhaseForm : GenericCard
{
 bool alreadycalled;

 override void Init()
 {
  Super.Init();
  tier = 2;
  useSpecies = false;
  effectMonsters = true;
  description = "Some phase monsters will unleash their TRUE power.";
  canStack = false;
  image = "";
  background = "TPHASE";
  alwaysoffer = true;
 }

 override String GetValidSprite(Actor a)
 {
  return "TNT1A0";
 }

 override bool Condition()
 {
  if(Stringtable.Localize("$CCTP"..monsterFigure.GetClassName()).Length() == 1) {return true;}

  return false;
 }

 override void PreGameStart()
 {
  alreadycalled = false;
 }

 override void OnGameStart(actor a)
 { 
  int phaselimit;
  if(!alreadycalled)
  {
   alreadycalled = true;
   let global = TonynGlobal.Get();    let gp = CCards_Functions.GetGame();

   if(!gp.permanentChoice) {phaselimit = random(20,45);}
   else if(global)
   {
    phaselimit = random(5+(global.tphasecount/2),20+global.tphasecount);
    global.tphasecount++;
   }

   ThinkerIterator ti = ThinkerIterator.Create("Actor");
   Actor t;
 		
   while( (t = Actor(ti.Next())) && phaselimit > 0 )
   {
    if(t && Stringtable.Localize("$CCTP"..t.GetClassName()).Length() == 1 )
     {
      int phasevalue = Stringtable.Localize("$CCTP"..t.GetClassName()).ToInt(10);
      t.GiveInventory("CFTruePhaser",1);
      phaselimit -= phasevalue;
     }
   }

  }
 }

} //end card


Class CFTruePhaser : Inventory
{
 Default 
 {
  Inventory.Amount 1;
  Inventory.MaxAmount 1;
 }

 bool phased;
 int duration,cooldown,cdmultiplier,phasing,oldalpha,oldstyle;


 override void DoEffect()
 {
  Super.DoEffect();

  if(owner && owner.Health > 0) 
  {
   if(duration && owner.Alpha >= 0.0) {owner.Alpha -= 0.02;}
   else if (!duration)
   {
    if(owner.Alpha < oldalpha) {owner.Alpha += 0.04;}
    else if(phasing) 
    {
     owner.Alpha = oldalpha;
     owner.A_SetRenderStyle(owner.alpha,oldstyle);
     phasing = 0;
    }
   }
  }
 }


 States
 {
  Held:
	TNT1 A 1;
	TNT1 A 1
	{
	 if(!owner) {self.Destroy(); return;}
	 oldstyle = owner.GetRenderStyle();
	 oldalpha = (owner.alpha ? owner.alpha : 1.0);
	 cdmultiplier = Stringtable.Localize("$CCTP"..owner.GetClassName()).ToInt(10);
	}
  Held2:
	TNT1 A 35
	{
	 if(!owner) {self.Destroy(); return;}

	 if( InStateSequence(owner.CurState,owner.ResolveState("Spawn")) || 
	     InStateSequence(owner.CurState,owner.ResolveState("Idle")) )
	   {return;}

	 if(cooldown) {cooldown--; return;}

	 if(!phased)
	  {
	    phased = true;  duration = random(10,25); phasing = 1;
	    owner.A_SetRenderStyle(owner.alpha,Style_Add);
	    owner.A_StartSound("cfcards/phasein",0);
	    owner.A_ChangeLinkFlags(true);   owner.bISMONSTER = false;
	  }

	 else
	  {
	   if(duration) {duration--; return;}

	   phased = false;  cooldown = 16*cdmultiplier;
	   owner.A_StartSound("cfcards/phaseout",0);
	   owner.A_ChangeLinkFlags(false);   owner.bISMONSTER = true;
	  }
	}
	Loop;
 }

}
