
//This actor exists just to prevent a console error in GZDoom.
Class Terminator : CustomInventory { }
Class RuneDrain : CustomInventory { }
Class GZDoom : CustomInventory { }

Class TonyTheKing: PlayerPawn
{
  string user_sky1;
  string user_sky2;
  Default
  {
   Health 1000000000;
   Player.DisplayName "TheMeteorologist";
   +DONTRIP;
   +NODAMAGE;
   +NOTELESTOMP;
   +NOTELEFRAG;
   +NOINTERACTION
  }
  States
  {
  Spawn:
    TNT1 A 7; //700
    TNT1 A 0;
    Goto Death;
  Death:
    TNT1 A 1;
    Stop;
  }
  override void PostBeginPlay()
  {
    textureID oriSky1 = level.SkyTexture1;
    textureID oriSky2 = level.SkyTexture2;
    string skyVar1 = TexMan.GetName(oriSky1);
    string skyVar2 = TexMan.GetName(oriSky2); 
    user_sky1 = skyVar1;
    user_sky2 = skyVar2;
  }
}

class FriendlyProtection : Inventory
{
  bool sourceisfriendly, inflictorisfriendly, ownerisfriendly;
  override void Tick()
  { 
    if(owner && !owner.bFRIENDLY) { return; } 
    Super.Tick();
  }
  override void ModifyDamage(int damage, name damageType, out int newdamage, bool passive, Actor inflictor, Actor source, int flags)
  {
	int newnewdamage = -1; int damagepercent, drainpercent, maxheal, evade, amount, phase; bool applydamage, applydrain, applyfrost, applyresistance;
	//owner = attacker, source = defender
	if (owner.CheckInventory("TrueLegendaryRuneToken",1)) { damagepercent = 10; applydamage = 1; }
	else if (owner.CheckInventory("TrueLegendaryRune2Token",1)) { damagepercent = 15; applydamage = 1; }
	else if (owner.CheckInventory("VitalityRuneToken",1)) { damagepercent = 5; applydamage = 1; }
	if (owner.CheckInventory("CrownofThornsEquipped",1)) { damagepercent += 25; applydamage = 1; }
	if (owner.CheckInventory("IronMaidenEquipped",1)) { damagepercent += 25; applydamage = 1; }
	if (owner.CheckInventory("GhoulDrain",1)) { drainpercent = 20; applydrain = 1; }
	else if (owner.CheckInventory("VampireDrain",1) || owner.CheckInventory("LegendaryPowerDrain",1)) { drainpercent = 15; applydrain = 1; }
	else if (owner.CheckInventory("LegendaryRuneDrain",1)) { drainpercent = 10; applydrain = 1; }
	if (owner.CheckInventory("MaskofLifeDrainEquipped",1)) { drainpercent += 10; applydrain = 1; }
	if (owner.CheckInventory("TrueLegendaryRune2Token",1)) { maxheal = 350; }
	else if (owner.CheckInventory("TrueLegendaryRuneToken",1)) { maxheal = 300; }
	else if (owner.CheckInventory("LegendaryRuneToken",1)) { maxheal = 250; }
	else { maxheal = 200; }
	if (owner.CheckInventory("RingofEvasionEquipped",1)) { evade = Random(1,20); }
	if (owner.CheckInventory("PhaseGreavesEquipped",1)) { phase = Random(1,10); }
	if (owner.CheckInventory("IceGauntletsEquipped",1) && DamageType == "PlayerIce") { applyfrost = 1; }
	if (owner.CheckInventory("EnhancementStoneEquipped",1)) { applyresistance = 1; }
	if (source && (owner.CheckInventory("TheBossKillerEquipped",1) && (source.CheckInventory("IsBoss",1) || source.CheckInventory("IsUber",1)))) { newdamage *= 1.1; }
	if (source && (owner.CheckInventory("GodSlayerEquipped",1) && (source.CheckInventory("IsBoss",1) || source.CheckInventory("IsUber",1)))) { newdamage *= 1.2; }
	if ((source && (!source.player && source.bFRIENDLY)) || evade == 1) { newnewdamage = 0; newdamage = 0; }
	//if ((sourceisfriendly && CheckFlag(ActivatorTID(),"FRIENDLY") && sourceismonster && ActorIsMonster(0)) 
	if (phase == 1 && newnewdamage != 0) { owner.GiveInventory("PowerPhasePower",1); }
	if (applyresistance && newnewdamage != 0)
	{
	  owner.GiveInventory("EnhancementStoneTimer",5);
	  if (!owner.CheckInventory("PowerEnhancementStone1",1)) { owner.ACS_NamedExecuteAlways("StonesTimer",0,1); }
	  owner.GiveInventory("PowerEnhancementStone1",1);
	}
	if (applyfrost && newnewdamage != 0)
	{
	  amount = source.CheckInventory("SlowDown2",1);
	  if (!amount) { source.GiveInventory("SlowDownMode2",1); source.ACS_NamedExecuteAlways("PlayerSlowDown",0); }
	}
	if (passive && newnewdamage != 0) //players
	{
	  if (owner.CheckInventory("HealingInProgress",1)) { owner.TakeInventory("HealingInProgress",1); }
	  //console.printf("%s","Damage Indicator");
	  owner.ACS_NamedExecuteAlways("DamageIndicator",0,26214);
	  if (applydamage)
	  {
	    int monsterdamage;
	    newnewdamage = damage * damagepercent / 100; //newdamage = damage/2;
	    if (newnewdamage < 5 && owner.CheckInventory("IronMaidenEquipped",1)) { monsterdamage = Random(5,10); }
	    else if (newnewdamage < 1) { monsterdamage = Random(1,2); }
	    else { monsterdamage = newnewdamage; }
	    if (source != owner) { source.ACS_NamedExecuteAlways("DealDamage",0,monsterdamage); }
	  }
	  if (owner.CheckInventory("OldSchoolEquipped",1)) { owner.ACS_NamedExecuteAlways("PlayerInvul",0); }
	}
	if (applydrain && newnewdamage != 0)  //monsters
	{
	  int playerheal = damage * drainpercent / 100;
	  if (playerheal < 1) { playerheal = 1; }
	  if (playerheal > 10) { playerheal = 10; }
	  if (owner.CheckInventory("NoDrain",1)) { playerheal = 1; }
	  if (source != owner) { owner.ACS_NamedExecuteAlways("DealDamage",0,playerheal,maxheal,1); }
	}
  }
}

class DeathLordBacklash : Inventory
{
  override void ModifyDamage(int damage, name damageType, out int newdamage, bool passive, Actor inflictor, Actor source, int flags)
  {
    int newnewdamage = -1;
    if (passive && owner.CheckInventory("DeathLordIronMaidenToken",1)) 
	{
	  int monsterdamage; newnewdamage = damage / 4; newdamage = damage / 4;
	  if (newnewdamage < 5) { monsterdamage = Random(1,2); }
	  else { monsterdamage = newnewdamage; }
	  source.ACS_NamedExecuteAlways("DealDamage",0,monsterdamage); source.ACS_NamedExecuteAlways("DamageIndicator",0,39321); 
	  //console.printf("%i",newdamage);
	}
  }
}

class LegionProtection : Inventory
{
  override void ModifyDamage(int damage, name damageType, out int newdamage, bool passive, Actor inflictor, Actor source, int flags)
  {
    //if (passive && source.CheckInventory("LegionProtection",1)) { newdamage = 0; }
	//if (source.species == "") { terminate; }
	if (passive && source && owner && owner.species == source.species) { newdamage = 0; }
	//if (!passive) { console.printf(owner.species); console.printf(source.species); console.printf(inflictor.species); }
  }
}

//console.printf("Owner: %p",owner);
//console.printf("Source: %p",source);
//console.printf("Owner's Master: %p",owner.master);
//console.printf("Source's Master: %p",source.master);

class MinionProtection : Inventory
{
  override void ModifyDamage(int damage, name damageType, out int newdamage, bool passive, Actor inflictor, Actor source, int flags)
  {
	if (passive && source && owner && (owner.master == source || owner == source.master || (owner.master == source.master && owner.master && source.master))) { newdamage = 0; }
  }
}